# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from creditas.api_client import ApiClient


class AuthorizationApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def a_ut_authorization_status_get_api(self, **kwargs):  # noqa: E501
        """Get authorization status  # noqa: E501

        Get SCA authorization status for given authorizationKey  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_authorization_status_get_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_authorization_status_get_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_authorization_status_get_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_authorization_status_get_api_with_http_info(self, **kwargs):  # noqa: E501
        """Get authorization status  # noqa: E501

        Get SCA authorization status for given authorizationKey  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_authorization_status_get_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_authorization_status_get_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/status/get', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def a_ut_mpin_esign_device_list_api(self, **kwargs):  # noqa: E501
        """Get device list for MpinEsign  # noqa: E501

        List of user's devices available for MpinEsign  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_mpin_esign_device_list_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_mpin_esign_device_list_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_mpin_esign_device_list_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_mpin_esign_device_list_api_with_http_info(self, **kwargs):  # noqa: E501
        """Get device list for MpinEsign  # noqa: E501

        List of user's devices available for MpinEsign  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_mpin_esign_device_list_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse2001
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_mpin_esign_device_list_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/mpinesign/device/list', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2001',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def a_ut_mpin_esign_initiate_api(self, **kwargs):  # noqa: E501
        """Initiate MpinEsign authorization  # noqa: E501

        Initiate transaction authorization using MpinEsign security tool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_mpin_esign_initiate_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body body: Input data structure
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_mpin_esign_initiate_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_mpin_esign_initiate_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_mpin_esign_initiate_api_with_http_info(self, **kwargs):  # noqa: E501
        """Initiate MpinEsign authorization  # noqa: E501

        Initiate transaction authorization using MpinEsign security tool  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_mpin_esign_initiate_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body body: Input data structure
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_mpin_esign_initiate_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/mpinesign/initiate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def a_ut_redirect_ib_initiate_api(self, **kwargs):  # noqa: E501
        """Initiate IB authorization  # noqa: E501

        Initiates transaction authorization using redirect to internet banking authorization page  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_redirect_ib_initiate_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body1 body: Input data structure
        :return: InlineResponse2002
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_redirect_ib_initiate_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_redirect_ib_initiate_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_redirect_ib_initiate_api_with_http_info(self, **kwargs):  # noqa: E501
        """Initiate IB authorization  # noqa: E501

        Initiates transaction authorization using redirect to internet banking authorization page  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_redirect_ib_initiate_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body1 body: Input data structure
        :return: InlineResponse2002
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_redirect_ib_initiate_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/ib/initiate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2002',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def a_ut_sms_otp_initiate_api(self, **kwargs):  # noqa: E501
        """Initiate SMS authorization  # noqa: E501

        Iniate transaction authorization process using SMS OTP auhtorization method. As a result the OTP is sent to user's security phone number  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_sms_otp_initiate_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_sms_otp_initiate_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_sms_otp_initiate_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_sms_otp_initiate_api_with_http_info(self, **kwargs):  # noqa: E501
        """Initiate SMS authorization  # noqa: E501

        Iniate transaction authorization process using SMS OTP auhtorization method. As a result the OTP is sent to user's security phone number  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_sms_otp_initiate_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_sms_otp_initiate_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/smsotp/initiate', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def a_ut_sms_otp_perform_api(self, **kwargs):  # noqa: E501
        """Perform SMS authorization  # noqa: E501

        Verify SMS one time password to complete the transaction authorization process  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_sms_otp_perform_api(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body2 body: Input data structure
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.a_ut_sms_otp_perform_api_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.a_ut_sms_otp_perform_api_with_http_info(**kwargs)  # noqa: E501
            return data

    def a_ut_sms_otp_perform_api_with_http_info(self, **kwargs):  # noqa: E501
        """Perform SMS authorization  # noqa: E501

        Verify SMS one time password to complete the transaction authorization process  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.a_ut_sms_otp_perform_api_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str authorization_bearer: Access token
        :param str authorization_key: Transaction authorization key for SCA
        :param Body2 body: Input data structure
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['authorization_bearer', 'authorization_key', 'body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method a_ut_sms_otp_perform_api" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization_bearer' in params:
            header_params['Authorization-Bearer'] = params['authorization_bearer']  # noqa: E501
        if 'authorization_key' in params:
            header_params['Authorization-Key'] = params['authorization_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # Authentication setting
        auth_settings = ['oauth_code', 'oauth_implicit']  # noqa: E501

        return self.api_client.call_api(
            '/authorization/smsotp/perform', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
