# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from creditas.configuration import Configuration


class AccountTransactionFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'category': 'str',
        'type': 'str',
        'partner_account': 'AccountTransactionFilterPartnerAccount',
        'amount_from': 'str',
        'amount_to': 'str',
        'date_from': 'date',
        'date_to': 'date',
        'variable_symbol': 'str',
        'specific_symbol': 'str',
        'constant_symbol': 'str',
        'payers_reference': 'str',
        'remittance_info': 'str',
        'payment_order_id': 'str',
        'bulk_payment_order_id': 'str'
    }

    attribute_map = {
        'category': 'category',
        'type': 'type',
        'partner_account': 'partnerAccount',
        'amount_from': 'amountFrom',
        'amount_to': 'amountTo',
        'date_from': 'dateFrom',
        'date_to': 'dateTo',
        'variable_symbol': 'variableSymbol',
        'specific_symbol': 'specificSymbol',
        'constant_symbol': 'constantSymbol',
        'payers_reference': 'payersReference',
        'remittance_info': 'remittanceInfo',
        'payment_order_id': 'paymentOrderId',
        'bulk_payment_order_id': 'bulkPaymentOrderId'
    }

    def __init__(self, category=None, type=None, partner_account=None, amount_from=None, amount_to=None, date_from=None, date_to=None, variable_symbol=None, specific_symbol=None, constant_symbol=None, payers_reference=None, remittance_info=None, payment_order_id=None, bulk_payment_order_id=None, _configuration=None):  # noqa: E501
        """AccountTransactionFilter - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._category = None
        self._type = None
        self._partner_account = None
        self._amount_from = None
        self._amount_to = None
        self._date_from = None
        self._date_to = None
        self._variable_symbol = None
        self._specific_symbol = None
        self._constant_symbol = None
        self._payers_reference = None
        self._remittance_info = None
        self._payment_order_id = None
        self._bulk_payment_order_id = None
        self.discriminator = None

        if category is not None:
            self.category = category
        if type is not None:
            self.type = type
        if partner_account is not None:
            self.partner_account = partner_account
        if amount_from is not None:
            self.amount_from = amount_from
        if amount_to is not None:
            self.amount_to = amount_to
        if date_from is not None:
            self.date_from = date_from
        if date_to is not None:
            self.date_to = date_to
        if variable_symbol is not None:
            self.variable_symbol = variable_symbol
        if specific_symbol is not None:
            self.specific_symbol = specific_symbol
        if constant_symbol is not None:
            self.constant_symbol = constant_symbol
        if payers_reference is not None:
            self.payers_reference = payers_reference
        if remittance_info is not None:
            self.remittance_info = remittance_info
        if payment_order_id is not None:
            self.payment_order_id = payment_order_id
        if bulk_payment_order_id is not None:
            self.bulk_payment_order_id = bulk_payment_order_id

    @property
    def category(self):
        """Gets the category of this AccountTransactionFilter.  # noqa: E501

        The transaction category  # noqa: E501

        :return: The category of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this AccountTransactionFilter.

        The transaction category  # noqa: E501

        :param category: The category of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["DOMESTIC", "FOREIGN", "CARD", "OTHER"]  # noqa: E501
        if (self._configuration.client_side_validation and
                category not in allowed_values):
            raise ValueError(
                "Invalid value for `category` ({0}), must be one of {1}"  # noqa: E501
                .format(category, allowed_values)
            )

        self._category = category

    @property
    def type(self):
        """Gets the type of this AccountTransactionFilter.  # noqa: E501

        The transaction type  # noqa: E501

        :return: The type of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AccountTransactionFilter.

        The transaction type  # noqa: E501

        :param type: The type of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREDIT", "DEBIT"]  # noqa: E501
        if (self._configuration.client_side_validation and
                type not in allowed_values):
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def partner_account(self):
        """Gets the partner_account of this AccountTransactionFilter.  # noqa: E501


        :return: The partner_account of this AccountTransactionFilter.  # noqa: E501
        :rtype: AccountTransactionFilterPartnerAccount
        """
        return self._partner_account

    @partner_account.setter
    def partner_account(self, partner_account):
        """Sets the partner_account of this AccountTransactionFilter.


        :param partner_account: The partner_account of this AccountTransactionFilter.  # noqa: E501
        :type: AccountTransactionFilterPartnerAccount
        """

        self._partner_account = partner_account

    @property
    def amount_from(self):
        """Gets the amount_from of this AccountTransactionFilter.  # noqa: E501

        The minimal transaction amount for filtering  # noqa: E501

        :return: The amount_from of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._amount_from

    @amount_from.setter
    def amount_from(self, amount_from):
        """Sets the amount_from of this AccountTransactionFilter.

        The minimal transaction amount for filtering  # noqa: E501

        :param amount_from: The amount_from of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """

        self._amount_from = amount_from

    @property
    def amount_to(self):
        """Gets the amount_to of this AccountTransactionFilter.  # noqa: E501

        The maximal transaction amount for filtering  # noqa: E501

        :return: The amount_to of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._amount_to

    @amount_to.setter
    def amount_to(self, amount_to):
        """Sets the amount_to of this AccountTransactionFilter.

        The maximal transaction amount for filtering  # noqa: E501

        :param amount_to: The amount_to of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """

        self._amount_to = amount_to

    @property
    def date_from(self):
        """Gets the date_from of this AccountTransactionFilter.  # noqa: E501

        The minimal effective/value date for filtering  # noqa: E501

        :return: The date_from of this AccountTransactionFilter.  # noqa: E501
        :rtype: date
        """
        return self._date_from

    @date_from.setter
    def date_from(self, date_from):
        """Sets the date_from of this AccountTransactionFilter.

        The minimal effective/value date for filtering  # noqa: E501

        :param date_from: The date_from of this AccountTransactionFilter.  # noqa: E501
        :type: date
        """

        self._date_from = date_from

    @property
    def date_to(self):
        """Gets the date_to of this AccountTransactionFilter.  # noqa: E501

        The maximal effective/value date for filtering  # noqa: E501

        :return: The date_to of this AccountTransactionFilter.  # noqa: E501
        :rtype: date
        """
        return self._date_to

    @date_to.setter
    def date_to(self, date_to):
        """Sets the date_to of this AccountTransactionFilter.

        The maximal effective/value date for filtering  # noqa: E501

        :param date_to: The date_to of this AccountTransactionFilter.  # noqa: E501
        :type: date
        """

        self._date_to = date_to

    @property
    def variable_symbol(self):
        """Gets the variable_symbol of this AccountTransactionFilter.  # noqa: E501

        The variable symbol (exact match)  # noqa: E501

        :return: The variable_symbol of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._variable_symbol

    @variable_symbol.setter
    def variable_symbol(self, variable_symbol):
        """Sets the variable_symbol of this AccountTransactionFilter.

        The variable symbol (exact match)  # noqa: E501

        :param variable_symbol: The variable_symbol of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                variable_symbol is not None and len(variable_symbol) > 10):
            raise ValueError("Invalid value for `variable_symbol`, length must be less than or equal to `10`")  # noqa: E501

        self._variable_symbol = variable_symbol

    @property
    def specific_symbol(self):
        """Gets the specific_symbol of this AccountTransactionFilter.  # noqa: E501

        The specific symbol (exact match)  # noqa: E501

        :return: The specific_symbol of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._specific_symbol

    @specific_symbol.setter
    def specific_symbol(self, specific_symbol):
        """Sets the specific_symbol of this AccountTransactionFilter.

        The specific symbol (exact match)  # noqa: E501

        :param specific_symbol: The specific_symbol of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                specific_symbol is not None and len(specific_symbol) > 10):
            raise ValueError("Invalid value for `specific_symbol`, length must be less than or equal to `10`")  # noqa: E501

        self._specific_symbol = specific_symbol

    @property
    def constant_symbol(self):
        """Gets the constant_symbol of this AccountTransactionFilter.  # noqa: E501

        The constant symbol (exact match)  # noqa: E501

        :return: The constant_symbol of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._constant_symbol

    @constant_symbol.setter
    def constant_symbol(self, constant_symbol):
        """Sets the constant_symbol of this AccountTransactionFilter.

        The constant symbol (exact match)  # noqa: E501

        :param constant_symbol: The constant_symbol of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                constant_symbol is not None and len(constant_symbol) > 4):
            raise ValueError("Invalid value for `constant_symbol`, length must be less than or equal to `4`")  # noqa: E501

        self._constant_symbol = constant_symbol

    @property
    def payers_reference(self):
        """Gets the payers_reference of this AccountTransactionFilter.  # noqa: E501

        Information allowing the beneficiary to identify the payment  # noqa: E501

        :return: The payers_reference of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._payers_reference

    @payers_reference.setter
    def payers_reference(self, payers_reference):
        """Sets the payers_reference of this AccountTransactionFilter.

        Information allowing the beneficiary to identify the payment  # noqa: E501

        :param payers_reference: The payers_reference of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                payers_reference is not None and len(payers_reference) > 35):
            raise ValueError("Invalid value for `payers_reference`, length must be less than or equal to `35`")  # noqa: E501

        self._payers_reference = payers_reference

    @property
    def remittance_info(self):
        """Gets the remittance_info of this AccountTransactionFilter.  # noqa: E501

        The remittance information - additional information for the payment beneficiary  # noqa: E501

        :return: The remittance_info of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._remittance_info

    @remittance_info.setter
    def remittance_info(self, remittance_info):
        """Sets the remittance_info of this AccountTransactionFilter.

        The remittance information - additional information for the payment beneficiary  # noqa: E501

        :param remittance_info: The remittance_info of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                remittance_info is not None and len(remittance_info) > 140):
            raise ValueError("Invalid value for `remittance_info`, length must be less than or equal to `140`")  # noqa: E501

        self._remittance_info = remittance_info

    @property
    def payment_order_id(self):
        """Gets the payment_order_id of this AccountTransactionFilter.  # noqa: E501

        The unique identifier for the payment order the transaction is associated with  # noqa: E501

        :return: The payment_order_id of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._payment_order_id

    @payment_order_id.setter
    def payment_order_id(self, payment_order_id):
        """Sets the payment_order_id of this AccountTransactionFilter.

        The unique identifier for the payment order the transaction is associated with  # noqa: E501

        :param payment_order_id: The payment_order_id of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                payment_order_id is not None and len(payment_order_id) > 40):
            raise ValueError("Invalid value for `payment_order_id`, length must be less than or equal to `40`")  # noqa: E501

        self._payment_order_id = payment_order_id

    @property
    def bulk_payment_order_id(self):
        """Gets the bulk_payment_order_id of this AccountTransactionFilter.  # noqa: E501

        The unique identifier for the bulk payment order the transaction is associated with  # noqa: E501

        :return: The bulk_payment_order_id of this AccountTransactionFilter.  # noqa: E501
        :rtype: str
        """
        return self._bulk_payment_order_id

    @bulk_payment_order_id.setter
    def bulk_payment_order_id(self, bulk_payment_order_id):
        """Sets the bulk_payment_order_id of this AccountTransactionFilter.

        The unique identifier for the bulk payment order the transaction is associated with  # noqa: E501

        :param bulk_payment_order_id: The bulk_payment_order_id of this AccountTransactionFilter.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                bulk_payment_order_id is not None and len(bulk_payment_order_id) > 40):
            raise ValueError("Invalid value for `bulk_payment_order_id`, length must be less than or equal to `40`")  # noqa: E501

        self._bulk_payment_order_id = bulk_payment_order_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AccountTransactionFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountTransactionFilter):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountTransactionFilter):
            return True

        return self.to_dict() != other.to_dict()
