# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from creditas.configuration import Configuration


class Body11(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'date_from': 'date',
        'date_to': 'date',
        'page_item_count': 'int',
        'page_index': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'date_from': 'dateFrom',
        'date_to': 'dateTo',
        'page_item_count': 'pageItemCount',
        'page_index': 'pageIndex'
    }

    def __init__(self, account_id=None, date_from=None, date_to=None, page_item_count=None, page_index=None, _configuration=None):  # noqa: E501
        """Body11 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account_id = None
        self._date_from = None
        self._date_to = None
        self._page_item_count = None
        self._page_index = None
        self.discriminator = None

        self.account_id = account_id
        if date_from is not None:
            self.date_from = date_from
        if date_to is not None:
            self.date_to = date_to
        self.page_item_count = page_item_count
        self.page_index = page_index

    @property
    def account_id(self):
        """Gets the account_id of this Body11.  # noqa: E501

        The account id  # noqa: E501

        :return: The account_id of this Body11.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this Body11.

        The account id  # noqa: E501

        :param account_id: The account_id of this Body11.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                account_id is not None and len(account_id) > 40):
            raise ValueError("Invalid value for `account_id`, length must be less than or equal to `40`")  # noqa: E501

        self._account_id = account_id

    @property
    def date_from(self):
        """Gets the date_from of this Body11.  # noqa: E501

        Minimal Effective/value date (Datum realizace)  # noqa: E501

        :return: The date_from of this Body11.  # noqa: E501
        :rtype: date
        """
        return self._date_from

    @date_from.setter
    def date_from(self, date_from):
        """Sets the date_from of this Body11.

        Minimal Effective/value date (Datum realizace)  # noqa: E501

        :param date_from: The date_from of this Body11.  # noqa: E501
        :type: date
        """

        self._date_from = date_from

    @property
    def date_to(self):
        """Gets the date_to of this Body11.  # noqa: E501

        Maximal Effective/value date (Datum realizace)  # noqa: E501

        :return: The date_to of this Body11.  # noqa: E501
        :rtype: date
        """
        return self._date_to

    @date_to.setter
    def date_to(self, date_to):
        """Sets the date_to of this Body11.

        Maximal Effective/value date (Datum realizace)  # noqa: E501

        :param date_to: The date_to of this Body11.  # noqa: E501
        :type: date
        """

        self._date_to = date_to

    @property
    def page_item_count(self):
        """Gets the page_item_count of this Body11.  # noqa: E501

        The number of items per page  # noqa: E501

        :return: The page_item_count of this Body11.  # noqa: E501
        :rtype: int
        """
        return self._page_item_count

    @page_item_count.setter
    def page_item_count(self, page_item_count):
        """Sets the page_item_count of this Body11.

        The number of items per page  # noqa: E501

        :param page_item_count: The page_item_count of this Body11.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and page_item_count is None:
            raise ValueError("Invalid value for `page_item_count`, must not be `None`")  # noqa: E501

        self._page_item_count = page_item_count

    @property
    def page_index(self):
        """Gets the page_index of this Body11.  # noqa: E501

        The page number to be returned  # noqa: E501

        :return: The page_index of this Body11.  # noqa: E501
        :rtype: int
        """
        return self._page_index

    @page_index.setter
    def page_index(self, page_index):
        """Sets the page_index of this Body11.

        The page number to be returned  # noqa: E501

        :param page_index: The page_index of this Body11.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and page_index is None:
            raise ValueError("Invalid value for `page_index`, must not be `None`")  # noqa: E501

        self._page_index = page_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Body11, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Body11):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Body11):
            return True

        return self.to_dict() != other.to_dict()
