# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from creditas.configuration import Configuration


class Body27(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'format': 'str',
        'period': 'str',
        'year': 'int',
        'number': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'format': 'format',
        'period': 'period',
        'year': 'year',
        'number': 'number'
    }

    def __init__(self, account_id=None, format=None, period=None, year=None, number=None, _configuration=None):  # noqa: E501
        """Body27 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._account_id = None
        self._format = None
        self._period = None
        self._year = None
        self._number = None
        self.discriminator = None

        self.account_id = account_id
        self.format = format
        self.period = period
        self.year = year
        self.number = number

    @property
    def account_id(self):
        """Gets the account_id of this Body27.  # noqa: E501

        The unique identifier for the bank account  # noqa: E501

        :return: The account_id of this Body27.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this Body27.

        The unique identifier for the bank account  # noqa: E501

        :param account_id: The account_id of this Body27.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                account_id is not None and len(account_id) > 40):
            raise ValueError("Invalid value for `account_id`, length must be less than or equal to `40`")  # noqa: E501

        self._account_id = account_id

    @property
    def format(self):
        """Gets the format of this Body27.  # noqa: E501

        The requested statement format  # noqa: E501

        :return: The format of this Body27.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this Body27.

        The requested statement format  # noqa: E501

        :param format: The format of this Body27.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and format is None:
            raise ValueError("Invalid value for `format`, must not be `None`")  # noqa: E501
        allowed_values = ["PDF", "ABO"]  # noqa: E501
        if (self._configuration.client_side_validation and
                format not in allowed_values):
            raise ValueError(
                "Invalid value for `format` ({0}), must be one of {1}"  # noqa: E501
                .format(format, allowed_values)
            )

        self._format = format

    @property
    def period(self):
        """Gets the period of this Body27.  # noqa: E501

        The period of requested statement (Only monthly statements are supported)  # noqa: E501

        :return: The period of this Body27.  # noqa: E501
        :rtype: str
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this Body27.

        The period of requested statement (Only monthly statements are supported)  # noqa: E501

        :param period: The period of this Body27.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and period is None:
            raise ValueError("Invalid value for `period`, must not be `None`")  # noqa: E501
        allowed_values = ["DAY", "WEEK", "MONTH", "QUARTER", "HALF", "YEAR"]  # noqa: E501
        if (self._configuration.client_side_validation and
                period not in allowed_values):
            raise ValueError(
                "Invalid value for `period` ({0}), must be one of {1}"  # noqa: E501
                .format(period, allowed_values)
            )

        self._period = period

    @property
    def year(self):
        """Gets the year of this Body27.  # noqa: E501

        The statement's year  # noqa: E501

        :return: The year of this Body27.  # noqa: E501
        :rtype: int
        """
        return self._year

    @year.setter
    def year(self, year):
        """Sets the year of this Body27.

        The statement's year  # noqa: E501

        :param year: The year of this Body27.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and year is None:
            raise ValueError("Invalid value for `year`, must not be `None`")  # noqa: E501

        self._year = year

    @property
    def number(self):
        """Gets the number of this Body27.  # noqa: E501

        The statement's sequence number  # noqa: E501

        :return: The number of this Body27.  # noqa: E501
        :rtype: int
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this Body27.

        The statement's sequence number  # noqa: E501

        :param number: The number of this Body27.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and number is None:
            raise ValueError("Invalid value for `number`, must not be `None`")  # noqa: E501

        self._number = number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Body27, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Body27):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Body27):
            return True

        return self.to_dict() != other.to_dict()
