# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from creditas.configuration import Configuration


class PaymentOrderDomesticPartnerAccount(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'bban': 'str',
        'bank_code': 'str',
        'iban': 'str',
        'bic': 'str'
    }

    attribute_map = {
        'bban': 'bban',
        'bank_code': 'bankCode',
        'iban': 'iban',
        'bic': 'bic'
    }

    def __init__(self, bban=None, bank_code=None, iban=None, bic=None, _configuration=None):  # noqa: E501
        """PaymentOrderDomesticPartnerAccount - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._bban = None
        self._bank_code = None
        self._iban = None
        self._bic = None
        self.discriminator = None

        if bban is not None:
            self.bban = bban
        if bank_code is not None:
            self.bank_code = bank_code
        if iban is not None:
            self.iban = iban
        if bic is not None:
            self.bic = bic

    @property
    def bban(self):
        """Gets the bban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501

        BBAN (Basic Bank Account Number) The country-specific account number  # noqa: E501

        :return: The bban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bban

    @bban.setter
    def bban(self, bban):
        """Sets the bban of this PaymentOrderDomesticPartnerAccount.

        BBAN (Basic Bank Account Number) The country-specific account number  # noqa: E501

        :param bban: The bban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bban = bban

    @property
    def bank_code(self):
        """Gets the bank_code of this PaymentOrderDomesticPartnerAccount.  # noqa: E501

        The country specific bank code  # noqa: E501

        :return: The bank_code of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_code

    @bank_code.setter
    def bank_code(self, bank_code):
        """Sets the bank_code of this PaymentOrderDomesticPartnerAccount.

        The country specific bank code  # noqa: E501

        :param bank_code: The bank_code of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bank_code = bank_code

    @property
    def iban(self):
        """Gets the iban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501

        IBAN (International Bank Account Number)  # noqa: E501

        :return: The iban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._iban

    @iban.setter
    def iban(self, iban):
        """Sets the iban of this PaymentOrderDomesticPartnerAccount.

        IBAN (International Bank Account Number)  # noqa: E501

        :param iban: The iban of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :type: str
        """

        self._iban = iban

    @property
    def bic(self):
        """Gets the bic of this PaymentOrderDomesticPartnerAccount.  # noqa: E501

        BIC (Business Identification Code) - International unique identifier for the bank  # noqa: E501

        :return: The bic of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bic

    @bic.setter
    def bic(self, bic):
        """Sets the bic of this PaymentOrderDomesticPartnerAccount.

        BIC (Business Identification Code) - International unique identifier for the bank  # noqa: E501

        :param bic: The bic of this PaymentOrderDomesticPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bic = bic

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentOrderDomesticPartnerAccount, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentOrderDomesticPartnerAccount):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaymentOrderDomesticPartnerAccount):
            return True

        return self.to_dict() != other.to_dict()
