# coding: utf-8

"""
    Creditas OpenAPI

    This is specification of the Creditas OpenAPI. It contains definitions of Creditas banking services exposed via API accessible on the internet.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: is@creditas.cz
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from creditas.configuration import Configuration


class PaymentOrderForeignPartnerAccount(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number': 'str',
        'bic': 'str',
        'bank_name': 'str',
        'bank_address': 'str',
        'partner_name': 'str',
        'partner_adress': 'str'
    }

    attribute_map = {
        'number': 'number',
        'bic': 'bic',
        'bank_name': 'bankName',
        'bank_address': 'bankAddress',
        'partner_name': 'partnerName',
        'partner_adress': 'partnerAdress'
    }

    def __init__(self, number=None, bic=None, bank_name=None, bank_address=None, partner_name=None, partner_adress=None, _configuration=None):  # noqa: E501
        """PaymentOrderForeignPartnerAccount - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._number = None
        self._bic = None
        self._bank_name = None
        self._bank_address = None
        self._partner_name = None
        self._partner_adress = None
        self.discriminator = None

        if number is not None:
            self.number = number
        if bic is not None:
            self.bic = bic
        if bank_name is not None:
            self.bank_name = bank_name
        if bank_address is not None:
            self.bank_address = bank_address
        if partner_name is not None:
            self.partner_name = partner_name
        if partner_adress is not None:
            self.partner_adress = partner_adress

    @property
    def number(self):
        """Gets the number of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        BBAN (Basic Bank Account Number) The country-specific account number or IBAN  # noqa: E501

        :return: The number of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._number

    @number.setter
    def number(self, number):
        """Sets the number of this PaymentOrderForeignPartnerAccount.

        BBAN (Basic Bank Account Number) The country-specific account number or IBAN  # noqa: E501

        :param number: The number of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._number = number

    @property
    def bic(self):
        """Gets the bic of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        BIC (Business Identification Code) - International unique identifier for the bank (SWIFT)  # noqa: E501

        :return: The bic of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bic

    @bic.setter
    def bic(self, bic):
        """Sets the bic of this PaymentOrderForeignPartnerAccount.

        BIC (Business Identification Code) - International unique identifier for the bank (SWIFT)  # noqa: E501

        :param bic: The bic of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bic = bic

    @property
    def bank_name(self):
        """Gets the bank_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        The beneficiary‘s bank name for SWIFT transaction  # noqa: E501

        :return: The bank_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_name

    @bank_name.setter
    def bank_name(self, bank_name):
        """Sets the bank_name of this PaymentOrderForeignPartnerAccount.

        The beneficiary‘s bank name for SWIFT transaction  # noqa: E501

        :param bank_name: The bank_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bank_name = bank_name

    @property
    def bank_address(self):
        """Gets the bank_address of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        The beneficiary‘s bank address for SWIFT transaction  # noqa: E501

        :return: The bank_address of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._bank_address

    @bank_address.setter
    def bank_address(self, bank_address):
        """Sets the bank_address of this PaymentOrderForeignPartnerAccount.

        The beneficiary‘s bank address for SWIFT transaction  # noqa: E501

        :param bank_address: The bank_address of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._bank_address = bank_address

    @property
    def partner_name(self):
        """Gets the partner_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        The beneficiary‘s name – a name and a surname or a company name  # noqa: E501

        :return: The partner_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._partner_name

    @partner_name.setter
    def partner_name(self, partner_name):
        """Sets the partner_name of this PaymentOrderForeignPartnerAccount.

        The beneficiary‘s name – a name and a surname or a company name  # noqa: E501

        :param partner_name: The partner_name of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._partner_name = partner_name

    @property
    def partner_adress(self):
        """Gets the partner_adress of this PaymentOrderForeignPartnerAccount.  # noqa: E501

        The beneficiary‘s address  # noqa: E501

        :return: The partner_adress of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :rtype: str
        """
        return self._partner_adress

    @partner_adress.setter
    def partner_adress(self, partner_adress):
        """Sets the partner_adress of this PaymentOrderForeignPartnerAccount.

        The beneficiary‘s address  # noqa: E501

        :param partner_adress: The partner_adress of this PaymentOrderForeignPartnerAccount.  # noqa: E501
        :type: str
        """

        self._partner_adress = partner_adress

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaymentOrderForeignPartnerAccount, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaymentOrderForeignPartnerAccount):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaymentOrderForeignPartnerAccount):
            return True

        return self.to_dict() != other.to_dict()
